#! /usr/bin/python

from urllib import urlopen
import re
import pyttsx
import serial
import webbrowser
import random
import time
from pymouse import PyMouse
from pykeyboard import PyKeyboard
from win32gui import GetWindowText, GetForegroundWindow

m = PyMouse()
k = PyKeyboard()

engine = pyttsx.init()

rate = engine.getProperty('rate')
engine.setProperty('rate', rate-10)
engine.say('Hey! Sophie here! What\'s up?')
engine.runAndWait()

hi_status = 0
    
# get the news headlines
def news_headlines():
    engine.say('Fetching news headlines from C N N')
    engine.runAndWait()
    webpage_news = urlopen('http://www.cnn.com/WORLD/').read()
    news_lines = re.compile('wo_c2" target="_self">(.*)</a>')
    findNews = re.findall(news_lines, webpage_news)
    news_i = 0
    news_counter = 5
    
    while news_i < news_counter:
        news_status = 0
        KEYWORKS = ['photos', 'see', 'See']
        for word in findNews[news_i].split():
            if word in KEYWORKS:
                news_status = 1
                news_counter = news_counter + 1
            else:
                news_i = news_i + 0
        if(news_status!=1):
            engine.say(findNews[news_i])
            engine.setProperty('rate', rate-20)
            engine.runAndWait() 
            time.sleep(0.5)
        news_i = news_i + 1

#pause whats playing on Pandora
def pause_Pandora():
    webbrowser.open_new_tab('https://www.google.com/')
    time.sleep(0.1)
    k.press_key(k.control_r_key)
    k.tap_key('w')
    k.release_key(k.control_r_key)
    time.sleep(0.1)
    tab_status = 0
    tab_counter = 0
    while tab_status == 0 and tab_counter < 15:
        tab_counter = tab_counter + 1
        k.press_key(k.control_r_key)
        k.tap_key(k.tab_key)
        k.release_key(k.control_r_key)
        time.sleep(0.1)
        web_tab = GetWindowText(GetForegroundWindow())
        print web_tab
        KEYWORKS = ['Pandora']
        for word in web_tab.split():
            if word in KEYWORKS:
                tab_status = 1
                break
    time.sleep(0.1)
    k.tap_key(' ')

while True:
    ser = serial.Serial('COM2', 9600) 

    data_raw = ser.read(7)
    msg = str(data_raw[3:6])
    print str(data_raw[3:6])
    
    ser.close()
    
    # dollar to ruppee rate, you can modify to use your currency
    if (msg == 'd-r'):
        webpage_rate = urlopen('http://finance.yahoo.com/q?s=USDINR=X').read()
        rate_raw = re.compile('<span id="yfs_l10_usdinr=x">(.*)</span></span> <span class')
        rate_USD = re.findall(rate_raw,webpage_rate)
        print str(rate_USD)[2:7]
        engine = pyttsx.init()
        rate = engine.getProperty('rate')
        engine.setProperty('rate', rate-30)
        engine.say('One U S Dollars is' + str(rate_USD)[2:7] + 'Ru-peas')
        engine.runAndWait()
        
    if (msg=='p_p'): # pause pandora
        pause_Pandora()
        
    if (msg=='nws'): # fetch news
        news_headlines()
        
    if (msg=='wea'): # fetch weather
        engine = pyttsx.init()
            
        rate = engine.getProperty('rate')
        engine.setProperty('rate', rate-30)
        # Copy all of the content from the provided web page
        webpage_WLAF = urlopen('http://www.weather.com/weather/today/47906:4:US').read() # 
        webpage_MLORE = urlopen('http://www.weather.com/weather/today/INXX0081:1:IN').read()  
        # Grab everything that lies between the title tags using a REGEX
            
        tempF = re.compile('data-share-desc="It\'s(.*)&deg;')
        condition = re.compile(' height="120" width="120" alt="(.*)" class="wx-weather-icon">')
        findCond = re.findall(condition,webpage_MLORE)
            
        # Store all of the titles and links found in 2 lists
        findTemp = re.findall(tempF,webpage_MLORE)
            
        if(len(str(findTemp))>0):
            temp_F = str(findTemp[0])
            temp_C= (int(temp_F)-32)*5/9
            engine.say('The temperature outside is '  + str(temp_C) +'degrees Celcius, or '+str(temp_F)+' degrees Fahrenheit')
            engine.say('And the weather is ' + str(findCond[0]))
        else:
            engine.say('Weather data is unavailable at this time')
        engine.runAndWait()
        print findCond
        data_raw=0
    
    # mentions flight details
    if (msg == 'fli'):
        engine.say('Your flight to Mars is on first April 2050, departing from the International Space Station')
        engine.runAndWait()
    
    # spam hello or hi
    if (msg == 'hi_'):
        rand_hi = random.randint(1,6)
        if(rand_hi== 1 and hi_status != 8):
            engine.say('Helo')
            engine.runAndWait()
        if(rand_hi== 2 and hi_status != 8):
            engine.say('Hi uh-di')
            engine.runAndWait()
        if(rand_hi== 3 and hi_status != 8):
            engine.say('Oops sorry was putting on my make up')
            engine.runAndWait()
        if(rand_hi== 4 and hi_status != 8):
            engine.say('What do you want?')
            engine.runAndWait()
        if(rand_hi== 5 and hi_status != 8):
            engine.say('You really want to play this game?')
            engine.runAndWait()
        if(rand_hi== 6 and hi_status != 8):
            engine.say('What\' up uh-dith')
            engine.runAndWait()
        if(hi_status == 8):
            engine.say('That\'s it! You\'re on your own!')
            engine.runAndWait()
            ser.close()
            ser = serial.Serial('COM2', 9600)
            apol_name = ser.read(7)
            msg_apol = str(apol_name[3:6])
            if (msg_apol!='sry'):
                    engine.say('I\'m still not talking to you')
                    engine.runAndWait()
            while (msg_apol!='sry'):
                ser.close()
                ser = serial.Serial('COM2', 9600)
                apol_name = ser.read(7)
                msg_apol = str(apol_name[3:6])
                
            engine.say('Could you say that just one more time?')
            engine.runAndWait()
            ser.close()
            ser = serial.Serial('COM2', 9600)
            apol_name = ser.read(7)
            msg_apol = str(apol_name[3:6])
            if(msg_apol == 'sry'):
                engine.say('I\'m gonna forgive you this time')
                engine.runAndWait()
            else:
                engine.say('I made you apologize to a computer!')
                engine.runAndWait()
            ser.close()
            hi_status= 6
        hi_status= hi_status+1
              
    # Use the following only if Pandora works in your country
    # Choose between Counting Stars, Green Day and Linkin Park or just ask for a surprise
    if(msg == 'w_p'):
        engine.say('What radio station would you like to listen to?')
        engine.runAndWait()
        ser = serial.Serial('COM2', 9600)
        station_name = ser.read(7)
        msg_station = str(station_name[3:6])
        ser.close()
        print str(data_raw[3:6])
        if(msg_station == 'rCS'): #Counting Stars
            engine.say('Here you go, enjoy.')
            engine.runAndWait()
            webbrowser.open_new_tab('http://www.pandora.com/station/play/1868633953743059637')
        elif(msg_station == 'rGD'): #Green Day
            engine.say('Here you go, enjoy.')
            engine.runAndWait()
            webbrowser.open_new_tab('http://www.pandora.com/station/play/1130735662934702773')
        elif(msg_station == 'rLP'):
            engine.say('Here you go, enjoy.')
            engine.runAndWait()
            webbrowser.open_new_tab('http://www.pandora.com/station/play/1130735512610847413')
        elif(msg_station == 'rOR'):
            engine.say('Here you go, enjoy.')
            engine.runAndWait()
            webbrowser.open_new_tab('http://www.pandora.com/station/play/2011719951690676917')
        elif(msg_station == 'rSX'):
            engine.say('It would be my pleasure.')
            engine.runAndWait()
            rand_no = random.randint(1,2)
            if(rand_no == 1):
                webbrowser.open_new_tab('https://www.youtube.com/watch?v=uC7JNUxJ1oA')
            if(rand_no == 2):
                webbrowser.open_new_tab('https://www.youtube.com/watch?v=Y6ljFaKRTrI')
        else:
            engine.say('I\'m sorry, I cannot find that radio station')
            engine.runAndWait()

